<?php

$nx = 320;
$ny = 250;
$file = "E:/FIT/magistr/7/dip/blif/obdelnik.blif";

function xy($ix, $iy) {
	return "x" . $ix . "y" . $iy;
}

$behav = array(
	"00 1",
	"01 1",
	"10 1",
	"11 1",
	"01 1\n10 1",
	"00 1\n11 1",
	"0- 1\n-0 1",
	"0- 1\n-1 1",
	"1- 1\n-0 1",
	"1- 1\n-1 1"
);

$ofs = fopen($file, "w");

fwrite($ofs, ".model Obdelnik\n");

fwrite($ofs, ".inputs");
for ($ix = 1; $ix <= $nx; $ix++) {
	fwrite($ofs, " " . xy($ix, 0));
}
for ($iy = 1; $iy <= $ny; $iy++) {
	fwrite($ofs, " " . xy(0, $iy));
}
fwrite($ofs, "\n");

fwrite($ofs, ".outputs");
for ($ix = 1; $ix <= $nx; $ix++) {
	fwrite($ofs, " " . xy($ix, $ny));
}
for ($iy = 1; $iy < $ny; $iy++) {
	fwrite($ofs, " " . xy($nx, $iy));
}
fwrite($ofs, "\n");

$behavN = count($behav);
for ($ix = 1; $ix <= $nx; $ix++) {
	for ($iy = 1; $iy <= $ny; $iy++) {
		fwrite($ofs, ".names " . xy($ix - 1, $iy) . " " . xy($ix, $iy - 1) . " " . xy($ix, $iy) . "\n");
		fwrite($ofs, $behav[rand(0, $behavN - 1)] . "\n");
	}
}

fwrite($ofs, ".end\n");

fclose($ofs);

?>
