class Heap {
private:
	bool valid;
	vector<Heapable *> data;
	MyRand *rnd;
public:
	Heap(MyRand &);
	void setValid(bool);
	void reset();
	void reserve(int);
	Heapable *getMin();
	bool insert(Heapable *);
	bool remove(const Heapable *);
private:
	void build();
	void heapifyUp(int i);
	void heapifyDown(int i);
	void heapifyStep(int &i, int j);
	int getLeftI(int i) const;
	int getRightI(int i) const;
	static int getUpI(int i);
	void setI(int i);
	bool testI(const Heapable *) const;
	int getMinUpI(int i) const;
	int getMinDownI(int i) const;
};
