class Mutex {
private:
	int size;
	SharedMem mem; // processes' attendance + global lock
	char *data; // local copy
	int lockI;
	bool locked; // locally
	int tag; // tag used in communication
	MyRand rnd;
	bool log;
public:
	Mutex(int tag, bool log);
	~Mutex();
	bool lock();
	bool unlock();
private:
	bool get(int adr);
	void put(bool val, int adr);
	void getData();
	void putData(); // for init
	void send(int val, int dest) const;
	void recv(int &val, int &src) const;
	void recv2(int &val, int &src) const; // to filter pokes
};
