class __attribute__((packed)) Scheduler : public Storable {
private:
	int cwinN, methodN;
	int *counts; // of remaining tasks
	int countG, nextI;
	bool done; // atomic flag
public:
	Scheduler(int cwinN, int methodN);
	void reset();
	void submitWork(RWork &); // submit + get new
	bool isDone();
	void save();
private:
	void setPtrs();
	void load_0();
};
