#!/bin/bash
#PBS -N Diplomka
#PBS -l select=5:ncpus=1:mem=4gb
#PBS -l walltime=00:05:00

DATADIR="/auto/praha1/rusinluk/dip/test/"
cd $DATADIR || exit 1

DIPLOMKA="./rusinluk_dip   EPFL__sin.blif -m ../src/methods.txt   -n 3   -w 1 1 0 -r 0 1 0 -rand 0 0 -nwarn"
mpirun --mca btl tcp,self -np 5 ${DIPLOMKA}
